//+------------------------------------------------------------------+
//|                                                      Wavelet.mq5 |
//|                                                      Aleksej1966 |
//|                        https://www.mql5.com/ru/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "Aleksej1966"
#property link      "https://www.mql5.com/ru/users/aleksej1966"
#property version   "1.00"
#property script_show_inputs
#include <Graphics\Graphic.mqh>

input string InpWave="1";
input uchar Lvl=1;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   string s[];
   int size=StringSplit(InpWave,StringGetCharacter(",",0),s),
       lvl=MathMax(1,Lvl);
   long coeff[];
   ArrayResize(coeff,size);

   for(int i=0; i<size; i++)
      coeff[i]=StringToInteger(s[i]);

   for(int i=0;i<lvl;i++)
      CalcLvl(coeff);

   double x[];
   ArrayCopy(x,coeff);

   ChartSetInteger(0,CHART_SHOW,false);
   int w=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0),
       h=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0);

   CGraphic graph;
   graph.Create(0,"Graphic",0,0,0,w,h);
   CCurve *ts=graph.CurveAdd(x,CURVE_HISTOGRAM,InpWave);
   ts.LinesWidth(5);
   graph.CurvePlotAll();
   graph.Update();
   ChartScreenShot(0,"Wavelet"+InpWave+".png",w,h);
   Sleep(3000);
   graph.Destroy();
   ChartSetInteger(0,CHART_SHOW,true);
//----
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CalcLvl(long &array[])
  {
//---
   int size=ArraySize(array);
   long a[];
   ArrayResize(a,size+1);
   a[0]=array[0];
   for(int i=1;i<size;i++)
      a[i]=array[i]-array[i-1];
   a[size]=-array[size-1];
   ArrayCopy(array,a);
//---
  }
//+------------------------------------------------------------------+
